
#ifndef BYTE_ORDERING_HPP
#define BYTE_ORDERING_HPP

namespace marshall {

// Are there any others? 
enum byte_ordering_t { Unknown, Big, Little };

// Generic conversion function prototype
typedef void (*conversion_function_t)(const void*);

// Size-specific conversion function prototypes
typedef uint16_t (*conversion_function16_t)(const uint16_t*);
typedef uint32_t (*conversion_function32_t)(const uint32_t*);
typedef uint64_t (*conversion_function64_t)(const uint64_t*);

// Signature of the functions returning conversion functions
template <typename T, byte_ordering_t>
conversion_function_t conversion_function(void);

} // namespace marshall

#endif // BYTE_ORDERING_HPP

