#ifndef VECTOR_MARSHALL_HPP
#define VECTOR_MARSHALL_HPP

#ifdef BOOST_SERIALIZATION_VECTOR_HPP
#error File vector_marshall.hpp is incompatible with file serialization/vector.hpp already included
#endif

#include <vector>
#include <boost/serialization/split_free.hpp>

namespace boost { 
namespace serialization {

// Declare that vectors can be serialized to/from network archives
template<class Archive, class T, class A>
inline void serialize(Archive & ar, std::vector<T, A> & v, const unsigned version)
{
    split_free(ar, v, version);
}

} // namespace serialization
} // namespace boost

#endif // VECTOR_MARSHALL_HPP
