
#include "xdr_iarchive.hpp"
#include <boost/archive/basic_binary_iprimitive.ipp>

namespace boost {
namespace archive {

using marshall::Big;

template class basic_binary_iprimitive<xdr_iarchive, std::istream>;
template class ordered_iarchive_impl<xdr_iarchive, Big>;

typedef ordered_binary_iprimitive<xdr_iarchive, std::istream, Big> xdr_iprimitive;

using marshall::conversion_function16_t;
using marshall::conversion_function32_t;
using marshall::conversion_function64_t;

template<>
void ordered_load<1, Big>(xdr_iprimitive* primitive, void* address)
{
  primitive->load_binary(address, 1);
}

template<>
void ordered_load<2, Big>(xdr_iprimitive* primitive, void* address)
{
  do_ordered_load<uint16_t, conversion_function16_t, Big, xdr_iprimitive>(primitive, address);
}

template<>
void ordered_load<4, Big>(xdr_iprimitive* primitive, void* address)
{
  do_ordered_load<uint32_t, conversion_function32_t, Big, xdr_iprimitive>(primitive, address);
}

#ifndef BOOST_NO_INT64_T
template<>
void ordered_load<8, Big>(xdr_iprimitive* primitive, void* address)
{
  do_ordered_load<uint64_t, conversion_function64_t, Big, xdr_iprimitive>(primitive, address);
}
#endif

} // namespace archive
} // namespace boost

