
#include "xdr_oarchive.hpp"
#include <boost/archive/basic_binary_oprimitive.ipp>

namespace boost {
namespace archive {

using marshall::Big;

template class basic_binary_oprimitive<xdr_oarchive, std::ostream>;
template class ordered_oarchive_impl<xdr_oarchive, Big>;

typedef ordered_binary_oprimitive<xdr_oarchive, std::ostream, Big> xdr_oprimitive;

using marshall::conversion_function16_t;
using marshall::conversion_function32_t;
using marshall::conversion_function64_t;

template<>
void ordered_save<1, Big>(xdr_oprimitive* primitive, const void* address)
{
  primitive->save_binary(address, 1);
}

template<>
void ordered_save<2, Big>(xdr_oprimitive* primitive, const void* address)
{
  do_ordered_save<uint16_t, conversion_function16_t, Big, xdr_oprimitive>(primitive, address);
}

template<>
void ordered_save<4, Big>(xdr_oprimitive* primitive, const void* address)
{
  do_ordered_save<uint32_t, conversion_function32_t, Big, xdr_oprimitive>(primitive, address);
}

#ifndef BOOST_NO_INT64_T
template<>
void ordered_save<8, Big>(xdr_oprimitive* primitive, const void* address)
{
  do_ordered_save<uint64_t, conversion_function64_t, Big, xdr_oprimitive>(primitive, address);
}
#endif

} // namespace archive
} // namespace boost

